local drawableRectangle = require("structs.drawable_rectangle")
local drawableSprite = require("structs.drawable_sprite")
local utils = require("utils")
local connectedEntities = require("helpers.connected_entities")
local ChroniaHelper = require("mods").requireFromPlugin("libraries.chroniaHelper")
local fo = require("mods").requireFromPlugin("helpers.field_options")
local vivUtils = require("mods").requireFromPlugin("libraries.vivUtilsMig")

local cloud = {}

cloud.name = "ChroniaHelper/CustomSummitCloud"

cloud.depth = function(room,entity) return entity.depth or -10550 end
cloud.placements = {
	name = "cloud",
	data = {
        path = "ChroniaHelper/CustomSummitClouds/cloud",
        color = "ffffff",
        floatiness = 1.0,
        depth = -10550,
        parallax = 1.0,
        randomizeParallax = true,
        randomFlipX = true,
        randomFlipY = false,
        alignment = "PositionTopLeft",
        screenPosX = 160,
        screenPosY = 90,
	},
}

cloud.fieldInformation = {
    depth = fo.depths,
    color = {
        fieldType = "color",
    },
    alignment = {
        options = {
            "PositionTopLeft", "PositionTopCenter", "PositionTopRight",
            "PositionCenterLeft", "PositionCenter", "PositionCenterRight",
            "PositionBottomLeft", "PositionBottomCenter", "PositionBottomRight",
            "AlignTopLeft", "AlignTopCenter", "AlignTopRight",
            "AlignCenterLeft", "AlignCenter", "AlignCenterRight",
            "AlignBottomLeft", "AlignBottomCenter", "AlignBottomRight"
        },
        editable = false,
    }
}

function cloud.sprite(room, entity)
    utils.setSimpleCoordinateSeed(entity.x, entity.y)

    local n = string.format("%02d", math.random(0,2))
    local m = math.random(0,2)
    local sprite = drawableSprite.fromTexture(entity.path .. n, entity)

    return sprite
end

cloud.selection = function(room, entity)
    return require('utils').rectangle(entity.x, entity.y, 8, 8)
end

return cloud